"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.de_UntagResourceCommand = exports.de_TagResourceCommand = exports.de_StopVectorEnrichmentJobCommand = exports.de_StopEarthObservationJobCommand = exports.de_StartVectorEnrichmentJobCommand = exports.de_StartEarthObservationJobCommand = exports.de_SearchRasterDataCollectionCommand = exports.de_ListVectorEnrichmentJobsCommand = exports.de_ListTagsForResourceCommand = exports.de_ListRasterDataCollectionsCommand = exports.de_ListEarthObservationJobsCommand = exports.de_GetVectorEnrichmentJobCommand = exports.de_GetTileCommand = exports.de_GetRasterDataCollectionCommand = exports.de_GetEarthObservationJobCommand = exports.de_ExportVectorEnrichmentJobCommand = exports.de_ExportEarthObservationJobCommand = exports.de_DeleteVectorEnrichmentJobCommand = exports.de_DeleteEarthObservationJobCommand = exports.se_UntagResourceCommand = exports.se_TagResourceCommand = exports.se_StopVectorEnrichmentJobCommand = exports.se_StopEarthObservationJobCommand = exports.se_StartVectorEnrichmentJobCommand = exports.se_StartEarthObservationJobCommand = exports.se_SearchRasterDataCollectionCommand = exports.se_ListVectorEnrichmentJobsCommand = exports.se_ListTagsForResourceCommand = exports.se_ListRasterDataCollectionsCommand = exports.se_ListEarthObservationJobsCommand = exports.se_GetVectorEnrichmentJobCommand = exports.se_GetTileCommand = exports.se_GetRasterDataCollectionCommand = exports.se_GetEarthObservationJobCommand = exports.se_ExportVectorEnrichmentJobCommand = exports.se_ExportEarthObservationJobCommand = exports.se_DeleteVectorEnrichmentJobCommand = exports.se_DeleteEarthObservationJobCommand = void 0;
const smithy_client_1 = require("@aws-sdk/smithy-client");
const protocol_http_1 = require("@smithy/protocol-http");
const uuid_1 = require("uuid");
const models_0_1 = require("../models/models_0");
const SageMakerGeospatialServiceException_1 = require("../models/SageMakerGeospatialServiceException");
const se_DeleteEarthObservationJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/earth-observation-jobs/{Arn}";
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "Arn", () => input.Arn, "{Arn}", false);
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_DeleteEarthObservationJobCommand = se_DeleteEarthObservationJobCommand;
const se_DeleteVectorEnrichmentJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/vector-enrichment-jobs/{Arn}";
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "Arn", () => input.Arn, "{Arn}", false);
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_DeleteVectorEnrichmentJobCommand = se_DeleteVectorEnrichmentJobCommand;
const se_ExportEarthObservationJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/export-earth-observation-job";
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        Arn: [],
        ClientToken: [true, (_) => _ ?? (0, uuid_1.v4)()],
        ExecutionRoleArn: [],
        ExportSourceImages: [],
        OutputConfig: (_) => (0, smithy_client_1._json)(_),
    }));
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_ExportEarthObservationJobCommand = se_ExportEarthObservationJobCommand;
const se_ExportVectorEnrichmentJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/export-vector-enrichment-jobs";
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        Arn: [],
        ClientToken: [true, (_) => _ ?? (0, uuid_1.v4)()],
        ExecutionRoleArn: [],
        OutputConfig: (_) => (0, smithy_client_1._json)(_),
    }));
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_ExportVectorEnrichmentJobCommand = se_ExportVectorEnrichmentJobCommand;
const se_GetEarthObservationJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/earth-observation-jobs/{Arn}";
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "Arn", () => input.Arn, "{Arn}", false);
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_GetEarthObservationJobCommand = se_GetEarthObservationJobCommand;
const se_GetRasterDataCollectionCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/raster-data-collection/{Arn}";
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "Arn", () => input.Arn, "{Arn}", false);
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_GetRasterDataCollectionCommand = se_GetRasterDataCollectionCommand;
const se_GetTileCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/tile/{z}/{x}/{y}";
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "x", () => input.x.toString(), "{x}", false);
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "y", () => input.y.toString(), "{y}", false);
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "z", () => input.z.toString(), "{z}", false);
    const query = (0, smithy_client_1.map)({
        ImageAssets: [
            (0, smithy_client_1.expectNonNull)(input.ImageAssets, `ImageAssets`) != null,
            () => (input.ImageAssets || []).map((_entry) => _entry),
        ],
        Target: [, (0, smithy_client_1.expectNonNull)(input.Target, `Target`)],
        Arn: [, (0, smithy_client_1.expectNonNull)(input.Arn, `Arn`)],
        ImageMask: [() => input.ImageMask !== void 0, () => input.ImageMask.toString()],
        OutputFormat: [, input.OutputFormat],
        TimeRangeFilter: [, input.TimeRangeFilter],
        PropertyFilters: [, input.PropertyFilters],
        OutputDataType: [, input.OutputDataType],
        ExecutionRoleArn: [, input.ExecutionRoleArn],
    });
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.se_GetTileCommand = se_GetTileCommand;
const se_GetVectorEnrichmentJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/vector-enrichment-jobs/{Arn}";
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "Arn", () => input.Arn, "{Arn}", false);
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_GetVectorEnrichmentJobCommand = se_GetVectorEnrichmentJobCommand;
const se_ListEarthObservationJobsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/list-earth-observation-jobs";
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        MaxResults: [],
        NextToken: [],
        SortBy: [],
        SortOrder: [],
        StatusEquals: [],
    }));
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_ListEarthObservationJobsCommand = se_ListEarthObservationJobsCommand;
const se_ListRasterDataCollectionsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    const resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/raster-data-collections";
    const query = (0, smithy_client_1.map)({
        NextToken: [, input.NextToken],
        MaxResults: [() => input.MaxResults !== void 0, () => input.MaxResults.toString()],
    });
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.se_ListRasterDataCollectionsCommand = se_ListRasterDataCollectionsCommand;
const se_ListTagsForResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{ResourceArn}";
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_ListTagsForResourceCommand = se_ListTagsForResourceCommand;
const se_ListVectorEnrichmentJobsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/list-vector-enrichment-jobs";
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        MaxResults: [],
        NextToken: [],
        SortBy: [],
        SortOrder: [],
        StatusEquals: [],
    }));
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_ListVectorEnrichmentJobsCommand = se_ListVectorEnrichmentJobsCommand;
const se_SearchRasterDataCollectionCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/search-raster-data-collection";
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        Arn: [],
        NextToken: [],
        RasterDataCollectionQuery: (_) => se_RasterDataCollectionQueryWithBandFilterInput(_, context),
    }));
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_SearchRasterDataCollectionCommand = se_SearchRasterDataCollectionCommand;
const se_StartEarthObservationJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/earth-observation-jobs";
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        ClientToken: [true, (_) => _ ?? (0, uuid_1.v4)()],
        ExecutionRoleArn: [],
        InputConfig: (_) => se_InputConfigInput(_, context),
        JobConfig: (_) => se_JobConfigInput(_, context),
        KmsKeyId: [],
        Name: [],
        Tags: (_) => (0, smithy_client_1._json)(_),
    }));
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_StartEarthObservationJobCommand = se_StartEarthObservationJobCommand;
const se_StartVectorEnrichmentJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/vector-enrichment-jobs";
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        ClientToken: [true, (_) => _ ?? (0, uuid_1.v4)()],
        ExecutionRoleArn: [],
        InputConfig: (_) => (0, smithy_client_1._json)(_),
        JobConfig: (_) => (0, smithy_client_1._json)(_),
        KmsKeyId: [],
        Name: [],
        Tags: (_) => (0, smithy_client_1._json)(_),
    }));
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_StartVectorEnrichmentJobCommand = se_StartVectorEnrichmentJobCommand;
const se_StopEarthObservationJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/earth-observation-jobs/stop";
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        Arn: [],
    }));
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_StopEarthObservationJobCommand = se_StopEarthObservationJobCommand;
const se_StopVectorEnrichmentJobCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/vector-enrichment-jobs/stop";
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        Arn: [],
    }));
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_StopVectorEnrichmentJobCommand = se_StopVectorEnrichmentJobCommand;
const se_TagResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    let resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{ResourceArn}";
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
    let body;
    body = JSON.stringify((0, smithy_client_1.take)(input, {
        Tags: (_) => (0, smithy_client_1._json)(_),
    }));
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "PUT",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.se_TagResourceCommand = se_TagResourceCommand;
const se_UntagResourceCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${basePath?.endsWith("/") ? basePath.slice(0, -1) : basePath || ""}` + "/tags/{ResourceArn}";
    resolvedPath = (0, smithy_client_1.resolvedPath)(resolvedPath, input, "ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
    const query = (0, smithy_client_1.map)({
        tagKeys: [
            (0, smithy_client_1.expectNonNull)(input.TagKeys, `TagKeys`) != null,
            () => (input.TagKeys || []).map((_entry) => _entry),
        ],
    });
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "DELETE",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.se_UntagResourceCommand = se_UntagResourceCommand;
const de_DeleteEarthObservationJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_DeleteEarthObservationJobCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_DeleteEarthObservationJobCommand = de_DeleteEarthObservationJobCommand;
const de_DeleteEarthObservationJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.sagemakergeospatial#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_DeleteVectorEnrichmentJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_DeleteVectorEnrichmentJobCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_DeleteVectorEnrichmentJobCommand = de_DeleteVectorEnrichmentJobCommand;
const de_DeleteVectorEnrichmentJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.sagemakergeospatial#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_ExportEarthObservationJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_ExportEarthObservationJobCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        Arn: smithy_client_1.expectString,
        CreationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        ExecutionRoleArn: smithy_client_1.expectString,
        ExportSourceImages: smithy_client_1.expectBoolean,
        ExportStatus: smithy_client_1.expectString,
        OutputConfig: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ExportEarthObservationJobCommand = de_ExportEarthObservationJobCommand;
const de_ExportEarthObservationJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.sagemakergeospatial#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.sagemakergeospatial#ServiceQuotaExceededException":
            throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_ExportVectorEnrichmentJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_ExportVectorEnrichmentJobCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        Arn: smithy_client_1.expectString,
        CreationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        ExecutionRoleArn: smithy_client_1.expectString,
        ExportStatus: smithy_client_1.expectString,
        OutputConfig: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ExportVectorEnrichmentJobCommand = de_ExportVectorEnrichmentJobCommand;
const de_ExportVectorEnrichmentJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.sagemakergeospatial#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.sagemakergeospatial#ServiceQuotaExceededException":
            throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_GetEarthObservationJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_GetEarthObservationJobCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        Arn: smithy_client_1.expectString,
        CreationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        DurationInSeconds: smithy_client_1.expectInt32,
        ErrorDetails: smithy_client_1._json,
        ExecutionRoleArn: smithy_client_1.expectString,
        ExportErrorDetails: smithy_client_1._json,
        ExportStatus: smithy_client_1.expectString,
        InputConfig: (_) => de_InputConfigOutput(_, context),
        JobConfig: (_) => de_JobConfigInput((0, smithy_client_1.expectUnion)(_), context),
        KmsKeyId: smithy_client_1.expectString,
        Name: smithy_client_1.expectString,
        OutputBands: smithy_client_1._json,
        Status: smithy_client_1.expectString,
        Tags: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_GetEarthObservationJobCommand = de_GetEarthObservationJobCommand;
const de_GetEarthObservationJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_GetRasterDataCollectionCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_GetRasterDataCollectionCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        Arn: smithy_client_1.expectString,
        Description: smithy_client_1.expectString,
        DescriptionPageUrl: smithy_client_1.expectString,
        ImageSourceBands: smithy_client_1._json,
        Name: smithy_client_1.expectString,
        SupportedFilters: (_) => de_FilterList(_, context),
        Tags: smithy_client_1._json,
        Type: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_GetRasterDataCollectionCommand = de_GetRasterDataCollectionCommand;
const de_GetRasterDataCollectionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_GetTileCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_GetTileCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = output.body;
    context.sdkStreamMixin(data);
    contents.BinaryFile = data;
    return contents;
};
exports.de_GetTileCommand = de_GetTileCommand;
const de_GetTileCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_GetVectorEnrichmentJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_GetVectorEnrichmentJobCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        Arn: smithy_client_1.expectString,
        CreationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        DurationInSeconds: smithy_client_1.expectInt32,
        ErrorDetails: smithy_client_1._json,
        ExecutionRoleArn: smithy_client_1.expectString,
        ExportErrorDetails: smithy_client_1._json,
        ExportStatus: smithy_client_1.expectString,
        InputConfig: smithy_client_1._json,
        JobConfig: (_) => (0, smithy_client_1._json)((0, smithy_client_1.expectUnion)(_)),
        KmsKeyId: smithy_client_1.expectString,
        Name: smithy_client_1.expectString,
        Status: smithy_client_1.expectString,
        Tags: smithy_client_1._json,
        Type: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_GetVectorEnrichmentJobCommand = de_GetVectorEnrichmentJobCommand;
const de_GetVectorEnrichmentJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_ListEarthObservationJobsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_ListEarthObservationJobsCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        EarthObservationJobSummaries: (_) => de_EarthObservationJobList(_, context),
        NextToken: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListEarthObservationJobsCommand = de_ListEarthObservationJobsCommand;
const de_ListEarthObservationJobsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_ListRasterDataCollectionsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_ListRasterDataCollectionsCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        NextToken: smithy_client_1.expectString,
        RasterDataCollectionSummaries: (_) => de_DataCollectionsList(_, context),
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListRasterDataCollectionsCommand = de_ListRasterDataCollectionsCommand;
const de_ListRasterDataCollectionsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_ListTagsForResourceCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        Tags: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListTagsForResourceCommand = de_ListTagsForResourceCommand;
const de_ListTagsForResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_ListVectorEnrichmentJobsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_ListVectorEnrichmentJobsCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        NextToken: smithy_client_1.expectString,
        VectorEnrichmentJobSummaries: (_) => de_VectorEnrichmentJobList(_, context),
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_ListVectorEnrichmentJobsCommand = de_ListVectorEnrichmentJobsCommand;
const de_ListVectorEnrichmentJobsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_SearchRasterDataCollectionCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_SearchRasterDataCollectionCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        ApproximateResultCount: smithy_client_1.expectInt32,
        Items: (_) => de_ItemSourceList(_, context),
        NextToken: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_SearchRasterDataCollectionCommand = de_SearchRasterDataCollectionCommand;
const de_SearchRasterDataCollectionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_StartEarthObservationJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_StartEarthObservationJobCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        Arn: smithy_client_1.expectString,
        CreationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        DurationInSeconds: smithy_client_1.expectInt32,
        ExecutionRoleArn: smithy_client_1.expectString,
        InputConfig: (_) => de_InputConfigOutput(_, context),
        JobConfig: (_) => de_JobConfigInput((0, smithy_client_1.expectUnion)(_), context),
        KmsKeyId: smithy_client_1.expectString,
        Name: smithy_client_1.expectString,
        Status: smithy_client_1.expectString,
        Tags: smithy_client_1._json,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_StartEarthObservationJobCommand = de_StartEarthObservationJobCommand;
const de_StartEarthObservationJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.sagemakergeospatial#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.sagemakergeospatial#ServiceQuotaExceededException":
            throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_StartVectorEnrichmentJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_StartVectorEnrichmentJobCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    const doc = (0, smithy_client_1.take)(data, {
        Arn: smithy_client_1.expectString,
        CreationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        DurationInSeconds: smithy_client_1.expectInt32,
        ExecutionRoleArn: smithy_client_1.expectString,
        InputConfig: smithy_client_1._json,
        JobConfig: (_) => (0, smithy_client_1._json)((0, smithy_client_1.expectUnion)(_)),
        KmsKeyId: smithy_client_1.expectString,
        Name: smithy_client_1.expectString,
        Status: smithy_client_1.expectString,
        Tags: smithy_client_1._json,
        Type: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    return contents;
};
exports.de_StartVectorEnrichmentJobCommand = de_StartVectorEnrichmentJobCommand;
const de_StartVectorEnrichmentJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.sagemakergeospatial#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.sagemakergeospatial#ServiceQuotaExceededException":
            throw await de_ServiceQuotaExceededExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_StopEarthObservationJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_StopEarthObservationJobCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_StopEarthObservationJobCommand = de_StopEarthObservationJobCommand;
const de_StopEarthObservationJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.sagemakergeospatial#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_StopVectorEnrichmentJobCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_StopVectorEnrichmentJobCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_StopVectorEnrichmentJobCommand = de_StopVectorEnrichmentJobCommand;
const de_StopVectorEnrichmentJobCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "ConflictException":
        case "com.amazonaws.sagemakergeospatial#ConflictException":
            throw await de_ConflictExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_TagResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_TagResourceCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_TagResourceCommand = de_TagResourceCommand;
const de_TagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const de_UntagResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_UntagResourceCommandError(output, context);
    }
    const contents = (0, smithy_client_1.map)({
        $metadata: deserializeMetadata(output),
    });
    await (0, smithy_client_1.collectBody)(output.body, context);
    return contents;
};
exports.de_UntagResourceCommand = de_UntagResourceCommand;
const de_UntagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "AccessDeniedException":
        case "com.amazonaws.sagemakergeospatial#AccessDeniedException":
            throw await de_AccessDeniedExceptionRes(parsedOutput, context);
        case "InternalServerException":
        case "com.amazonaws.sagemakergeospatial#InternalServerException":
            throw await de_InternalServerExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.sagemakergeospatial#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.sagemakergeospatial#ThrottlingException":
            throw await de_ThrottlingExceptionRes(parsedOutput, context);
        case "ValidationException":
        case "com.amazonaws.sagemakergeospatial#ValidationException":
            throw await de_ValidationExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const throwDefaultError = (0, smithy_client_1.withBaseException)(SageMakerGeospatialServiceException_1.SageMakerGeospatialServiceException);
const de_AccessDeniedExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        Message: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.AccessDeniedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_ConflictExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        Message: smithy_client_1.expectString,
        ResourceId: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.ConflictException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_InternalServerExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        Message: smithy_client_1.expectString,
        ResourceId: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.InternalServerException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_ResourceNotFoundExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        Message: smithy_client_1.expectString,
        ResourceId: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_ServiceQuotaExceededExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        Message: smithy_client_1.expectString,
        ResourceId: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.ServiceQuotaExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_ThrottlingExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        Message: smithy_client_1.expectString,
        ResourceId: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.ThrottlingException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const de_ValidationExceptionRes = async (parsedOutput, context) => {
    const contents = (0, smithy_client_1.map)({});
    const data = parsedOutput.body;
    const doc = (0, smithy_client_1.take)(data, {
        Message: smithy_client_1.expectString,
        ResourceId: smithy_client_1.expectString,
    });
    Object.assign(contents, doc);
    const exception = new models_0_1.ValidationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const se_AreaOfInterest = (input, context) => {
    return models_0_1.AreaOfInterest.visit(input, {
        AreaOfInterestGeometry: (value) => ({ AreaOfInterestGeometry: se_AreaOfInterestGeometry(value, context) }),
        _: (name, value) => ({ name: value }),
    });
};
const se_AreaOfInterestGeometry = (input, context) => {
    return models_0_1.AreaOfInterestGeometry.visit(input, {
        MultiPolygonGeometry: (value) => ({ MultiPolygonGeometry: se_MultiPolygonGeometryInput(value, context) }),
        PolygonGeometry: (value) => ({ PolygonGeometry: se_PolygonGeometryInput(value, context) }),
        _: (name, value) => ({ name: value }),
    });
};
const se_EoCloudCoverInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        LowerBound: smithy_client_1.serializeFloat,
        UpperBound: smithy_client_1.serializeFloat,
    });
};
const se_InputConfigInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        PreviousEarthObservationJobArn: [],
        RasterDataCollectionQuery: (_) => se_RasterDataCollectionQueryInput(_, context),
    });
};
const se_JobConfigInput = (input, context) => {
    return models_0_1.JobConfigInput.visit(input, {
        BandMathConfig: (value) => ({ BandMathConfig: (0, smithy_client_1._json)(value) }),
        CloudMaskingConfig: (value) => ({ CloudMaskingConfig: (0, smithy_client_1._json)(value) }),
        CloudRemovalConfig: (value) => ({ CloudRemovalConfig: (0, smithy_client_1._json)(value) }),
        GeoMosaicConfig: (value) => ({ GeoMosaicConfig: (0, smithy_client_1._json)(value) }),
        LandCoverSegmentationConfig: (value) => ({ LandCoverSegmentationConfig: (0, smithy_client_1._json)(value) }),
        ResamplingConfig: (value) => ({ ResamplingConfig: se_ResamplingConfigInput(value, context) }),
        StackConfig: (value) => ({ StackConfig: se_StackConfigInput(value, context) }),
        TemporalStatisticsConfig: (value) => ({ TemporalStatisticsConfig: (0, smithy_client_1._json)(value) }),
        ZonalStatisticsConfig: (value) => ({ ZonalStatisticsConfig: (0, smithy_client_1._json)(value) }),
        _: (name, value) => ({ name: value }),
    });
};
const se_LandsatCloudCoverLandInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        LowerBound: smithy_client_1.serializeFloat,
        UpperBound: smithy_client_1.serializeFloat,
    });
};
const se_LinearRing = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_Position(entry, context);
    });
};
const se_LinearRings = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_LinearRing(entry, context);
    });
};
const se_LinearRingsList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_LinearRings(entry, context);
    });
};
const se_MultiPolygonGeometryInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        Coordinates: (_) => se_LinearRingsList(_, context),
    });
};
const se_OutputResolutionResamplingInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        UserDefined: (_) => se_UserDefined(_, context),
    });
};
const se_OutputResolutionStackInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        Predefined: [],
        UserDefined: (_) => se_UserDefined(_, context),
    });
};
const se_PolygonGeometryInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        Coordinates: (_) => se_LinearRings(_, context),
    });
};
const se_Position = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return (0, smithy_client_1.serializeFloat)(entry);
    });
};
const se_Property = (input, context) => {
    return models_0_1.Property.visit(input, {
        EoCloudCover: (value) => ({ EoCloudCover: se_EoCloudCoverInput(value, context) }),
        LandsatCloudCoverLand: (value) => ({ LandsatCloudCoverLand: se_LandsatCloudCoverLandInput(value, context) }),
        Platform: (value) => ({ Platform: (0, smithy_client_1._json)(value) }),
        ViewOffNadir: (value) => ({ ViewOffNadir: se_ViewOffNadirInput(value, context) }),
        ViewSunAzimuth: (value) => ({ ViewSunAzimuth: se_ViewSunAzimuthInput(value, context) }),
        ViewSunElevation: (value) => ({ ViewSunElevation: se_ViewSunElevationInput(value, context) }),
        _: (name, value) => ({ name: value }),
    });
};
const se_PropertyFilter = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        Property: (_) => se_Property(_, context),
    });
};
const se_PropertyFilters = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        LogicalOperator: [],
        Properties: (_) => se_PropertyFiltersList(_, context),
    });
};
const se_PropertyFiltersList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return se_PropertyFilter(entry, context);
    });
};
const se_RasterDataCollectionQueryInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        AreaOfInterest: (_) => se_AreaOfInterest(_, context),
        PropertyFilters: (_) => se_PropertyFilters(_, context),
        RasterDataCollectionArn: [],
        TimeRangeFilter: (_) => se_TimeRangeFilterInput(_, context),
    });
};
const se_RasterDataCollectionQueryWithBandFilterInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        AreaOfInterest: (_) => se_AreaOfInterest(_, context),
        BandFilter: smithy_client_1._json,
        PropertyFilters: (_) => se_PropertyFilters(_, context),
        TimeRangeFilter: (_) => se_TimeRangeFilterInput(_, context),
    });
};
const se_ResamplingConfigInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        AlgorithmName: [],
        OutputResolution: (_) => se_OutputResolutionResamplingInput(_, context),
        TargetBands: smithy_client_1._json,
    });
};
const se_StackConfigInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        OutputResolution: (_) => se_OutputResolutionStackInput(_, context),
        TargetBands: smithy_client_1._json,
    });
};
const se_TimeRangeFilterInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        EndTime: (_) => Math.round(_.getTime() / 1000),
        StartTime: (_) => Math.round(_.getTime() / 1000),
    });
};
const se_UserDefined = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        Unit: [],
        Value: smithy_client_1.serializeFloat,
    });
};
const se_ViewOffNadirInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        LowerBound: smithy_client_1.serializeFloat,
        UpperBound: smithy_client_1.serializeFloat,
    });
};
const se_ViewSunAzimuthInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        LowerBound: smithy_client_1.serializeFloat,
        UpperBound: smithy_client_1.serializeFloat,
    });
};
const se_ViewSunElevationInput = (input, context) => {
    return (0, smithy_client_1.take)(input, {
        LowerBound: smithy_client_1.serializeFloat,
        UpperBound: smithy_client_1.serializeFloat,
    });
};
const de_AreaOfInterest = (output, context) => {
    if (output.AreaOfInterestGeometry != null) {
        return {
            AreaOfInterestGeometry: de_AreaOfInterestGeometry((0, smithy_client_1.expectUnion)(output.AreaOfInterestGeometry), context),
        };
    }
    return { $unknown: Object.entries(output)[0] };
};
const de_AreaOfInterestGeometry = (output, context) => {
    if (output.MultiPolygonGeometry != null) {
        return {
            MultiPolygonGeometry: de_MultiPolygonGeometryInput(output.MultiPolygonGeometry, context),
        };
    }
    if (output.PolygonGeometry != null) {
        return {
            PolygonGeometry: de_PolygonGeometryInput(output.PolygonGeometry, context),
        };
    }
    return { $unknown: Object.entries(output)[0] };
};
const de_DataCollectionsList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_RasterDataCollectionMetadata(entry, context);
    });
    return retVal;
};
const de_EarthObservationJobList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ListEarthObservationJobOutputConfig(entry, context);
    });
    return retVal;
};
const de_EoCloudCoverInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        LowerBound: smithy_client_1.limitedParseFloat32,
        UpperBound: smithy_client_1.limitedParseFloat32,
    });
};
const de_Filter = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Maximum: smithy_client_1.limitedParseFloat32,
        Minimum: smithy_client_1.limitedParseFloat32,
        Name: smithy_client_1.expectString,
        Type: smithy_client_1.expectString,
    });
};
const de_FilterList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_Filter(entry, context);
    });
    return retVal;
};
const de_Geometry = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Coordinates: (_) => de_LinearRings(_, context),
        Type: smithy_client_1.expectString,
    });
};
const de_InputConfigOutput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        PreviousEarthObservationJobArn: smithy_client_1.expectString,
        RasterDataCollectionQuery: (_) => de_RasterDataCollectionQueryOutput(_, context),
    });
};
const de_ItemSource = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Assets: smithy_client_1._json,
        DateTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(_))),
        Geometry: (_) => de_Geometry(_, context),
        Id: smithy_client_1.expectString,
        Properties: (_) => de_Properties(_, context),
    });
};
const de_ItemSourceList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ItemSource(entry, context);
    });
    return retVal;
};
const de_JobConfigInput = (output, context) => {
    if (output.BandMathConfig != null) {
        return {
            BandMathConfig: (0, smithy_client_1._json)(output.BandMathConfig),
        };
    }
    if (output.CloudMaskingConfig != null) {
        return {
            CloudMaskingConfig: (0, smithy_client_1._json)(output.CloudMaskingConfig),
        };
    }
    if (output.CloudRemovalConfig != null) {
        return {
            CloudRemovalConfig: (0, smithy_client_1._json)(output.CloudRemovalConfig),
        };
    }
    if (output.GeoMosaicConfig != null) {
        return {
            GeoMosaicConfig: (0, smithy_client_1._json)(output.GeoMosaicConfig),
        };
    }
    if (output.LandCoverSegmentationConfig != null) {
        return {
            LandCoverSegmentationConfig: (0, smithy_client_1._json)(output.LandCoverSegmentationConfig),
        };
    }
    if (output.ResamplingConfig != null) {
        return {
            ResamplingConfig: de_ResamplingConfigInput(output.ResamplingConfig, context),
        };
    }
    if (output.StackConfig != null) {
        return {
            StackConfig: de_StackConfigInput(output.StackConfig, context),
        };
    }
    if (output.TemporalStatisticsConfig != null) {
        return {
            TemporalStatisticsConfig: (0, smithy_client_1._json)(output.TemporalStatisticsConfig),
        };
    }
    if (output.ZonalStatisticsConfig != null) {
        return {
            ZonalStatisticsConfig: (0, smithy_client_1._json)(output.ZonalStatisticsConfig),
        };
    }
    return { $unknown: Object.entries(output)[0] };
};
const de_LandsatCloudCoverLandInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        LowerBound: smithy_client_1.limitedParseFloat32,
        UpperBound: smithy_client_1.limitedParseFloat32,
    });
};
const de_LinearRing = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_Position(entry, context);
    });
    return retVal;
};
const de_LinearRings = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_LinearRing(entry, context);
    });
    return retVal;
};
const de_LinearRingsList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_LinearRings(entry, context);
    });
    return retVal;
};
const de_ListEarthObservationJobOutputConfig = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Arn: smithy_client_1.expectString,
        CreationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        DurationInSeconds: smithy_client_1.expectInt32,
        Name: smithy_client_1.expectString,
        OperationType: smithy_client_1.expectString,
        Status: smithy_client_1.expectString,
        Tags: smithy_client_1._json,
    });
};
const de_ListVectorEnrichmentJobOutputConfig = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Arn: smithy_client_1.expectString,
        CreationTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        DurationInSeconds: smithy_client_1.expectInt32,
        Name: smithy_client_1.expectString,
        Status: smithy_client_1.expectString,
        Tags: smithy_client_1._json,
        Type: smithy_client_1.expectString,
    });
};
const de_MultiPolygonGeometryInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Coordinates: (_) => de_LinearRingsList(_, context),
    });
};
const de_OutputResolutionResamplingInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        UserDefined: (_) => de_UserDefined(_, context),
    });
};
const de_OutputResolutionStackInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Predefined: smithy_client_1.expectString,
        UserDefined: (_) => de_UserDefined(_, context),
    });
};
const de_PolygonGeometryInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Coordinates: (_) => de_LinearRings(_, context),
    });
};
const de_Position = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return (0, smithy_client_1.limitedParseDouble)(entry);
    });
    return retVal;
};
const de_Properties = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        EoCloudCover: smithy_client_1.limitedParseFloat32,
        LandsatCloudCoverLand: smithy_client_1.limitedParseFloat32,
        Platform: smithy_client_1.expectString,
        ViewOffNadir: smithy_client_1.limitedParseFloat32,
        ViewSunAzimuth: smithy_client_1.limitedParseFloat32,
        ViewSunElevation: smithy_client_1.limitedParseFloat32,
    });
};
const de_Property = (output, context) => {
    if (output.EoCloudCover != null) {
        return {
            EoCloudCover: de_EoCloudCoverInput(output.EoCloudCover, context),
        };
    }
    if (output.LandsatCloudCoverLand != null) {
        return {
            LandsatCloudCoverLand: de_LandsatCloudCoverLandInput(output.LandsatCloudCoverLand, context),
        };
    }
    if (output.Platform != null) {
        return {
            Platform: (0, smithy_client_1._json)(output.Platform),
        };
    }
    if (output.ViewOffNadir != null) {
        return {
            ViewOffNadir: de_ViewOffNadirInput(output.ViewOffNadir, context),
        };
    }
    if (output.ViewSunAzimuth != null) {
        return {
            ViewSunAzimuth: de_ViewSunAzimuthInput(output.ViewSunAzimuth, context),
        };
    }
    if (output.ViewSunElevation != null) {
        return {
            ViewSunElevation: de_ViewSunElevationInput(output.ViewSunElevation, context),
        };
    }
    return { $unknown: Object.entries(output)[0] };
};
const de_PropertyFilter = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Property: (_) => de_Property((0, smithy_client_1.expectUnion)(_), context),
    });
};
const de_PropertyFilters = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        LogicalOperator: smithy_client_1.expectString,
        Properties: (_) => de_PropertyFiltersList(_, context),
    });
};
const de_PropertyFiltersList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_PropertyFilter(entry, context);
    });
    return retVal;
};
const de_RasterDataCollectionMetadata = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Arn: smithy_client_1.expectString,
        Description: smithy_client_1.expectString,
        DescriptionPageUrl: smithy_client_1.expectString,
        Name: smithy_client_1.expectString,
        SupportedFilters: (_) => de_FilterList(_, context),
        Tags: smithy_client_1._json,
        Type: smithy_client_1.expectString,
    });
};
const de_RasterDataCollectionQueryOutput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        AreaOfInterest: (_) => de_AreaOfInterest((0, smithy_client_1.expectUnion)(_), context),
        PropertyFilters: (_) => de_PropertyFilters(_, context),
        RasterDataCollectionArn: smithy_client_1.expectString,
        RasterDataCollectionName: smithy_client_1.expectString,
        TimeRangeFilter: (_) => de_TimeRangeFilterOutput(_, context),
    });
};
const de_ResamplingConfigInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        AlgorithmName: smithy_client_1.expectString,
        OutputResolution: (_) => de_OutputResolutionResamplingInput(_, context),
        TargetBands: smithy_client_1._json,
    });
};
const de_StackConfigInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        OutputResolution: (_) => de_OutputResolutionStackInput(_, context),
        TargetBands: smithy_client_1._json,
    });
};
const de_TimeRangeFilterOutput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        EndTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
        StartTime: (_) => (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseRfc3339DateTimeWithOffset)(_)),
    });
};
const de_UserDefined = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        Unit: smithy_client_1.expectString,
        Value: smithy_client_1.limitedParseFloat32,
    });
};
const de_VectorEnrichmentJobList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_ListVectorEnrichmentJobOutputConfig(entry, context);
    });
    return retVal;
};
const de_ViewOffNadirInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        LowerBound: smithy_client_1.limitedParseFloat32,
        UpperBound: smithy_client_1.limitedParseFloat32,
    });
};
const de_ViewSunAzimuthInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        LowerBound: smithy_client_1.limitedParseFloat32,
        UpperBound: smithy_client_1.limitedParseFloat32,
    });
};
const de_ViewSunElevationInput = (output, context) => {
    return (0, smithy_client_1.take)(output, {
        LowerBound: smithy_client_1.limitedParseFloat32,
        UpperBound: smithy_client_1.limitedParseFloat32,
    });
};
const deserializeMetadata = (output) => ({
    httpStatusCode: output.statusCode,
    requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
    extendedRequestId: output.headers["x-amz-id-2"],
    cfId: output.headers["x-amz-cf-id"],
});
const collectBodyString = (streamBody, context) => (0, smithy_client_1.collectBody)(streamBody, context).then((body) => context.utf8Encoder(body));
const isSerializableHeaderValue = (value) => value !== undefined &&
    value !== null &&
    value !== "" &&
    (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
    (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const parseErrorBody = async (errorBody, context) => {
    const value = await parseBody(errorBody, context);
    value.message = value.message ?? value.Message;
    return value;
};
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (typeof cleanValue === "number") {
            cleanValue = cleanValue.toString();
        }
        if (cleanValue.indexOf(",") >= 0) {
            cleanValue = cleanValue.split(",")[0];
        }
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
};
