import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  StartVectorEnrichmentJobInput,
  StartVectorEnrichmentJobOutput,
} from "../models/models_0";
import {
  SageMakerGeospatialClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../SageMakerGeospatialClient";
export { __MetadataBearer, $Command };
export interface StartVectorEnrichmentJobCommandInput
  extends StartVectorEnrichmentJobInput {}
export interface StartVectorEnrichmentJobCommandOutput
  extends StartVectorEnrichmentJobOutput,
    __MetadataBearer {}
export declare class StartVectorEnrichmentJobCommand extends $Command<
  StartVectorEnrichmentJobCommandInput,
  StartVectorEnrichmentJobCommandOutput,
  SageMakerGeospatialClientResolvedConfig
> {
  readonly input: StartVectorEnrichmentJobCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: StartVectorEnrichmentJobCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: SageMakerGeospatialClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    StartVectorEnrichmentJobCommandInput,
    StartVectorEnrichmentJobCommandOutput
  >;
  private serialize;
  private deserialize;
}
